let logger = require('./log');
let mqtt = require('./mqttHandler');
let AItem = require('./AItem');


class M433SwitchItem extends AItem {
    constructor(floor, room, item, onCode, offCode) {
        super(floor, room, item);
        this.stateTopic = `${this.topicFirstPart}/state`;
        this.subscribeTopics = [this.stateTopic];
        this.stateFeedbackTopic = `${this.topicFirstPart}/state/feedback`;
        this.actionTopic = 'IoT/Mqtt433Gateway/Message';
        this.state = 'OFF';
        this.oldState = undefined;
        this.onCode = onCode;
        this.offCode = offCode;
    }

    processMessage(topic, payload) {
        this.state = payload;
        mqtt.send(this.stateFeedbackTopic, this.state);
        if (this.state != this.oldState) {                
            if (this.state == 'ON') {
                mqtt.send(this.actionTopic, this.onCode);
            } else {
                mqtt.send(this.actionTopic, this.offCode);
            }
            this.oldState = this.state;
        }
    }
}

module.exports = M433SwitchItem;

